#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <time.h>
#include <ctype.h>
#include <sys/time.h>
#include <string.h>

#define WIDTH 640
#define HEIGHT 480
#define antalAtt 3
#define WIDTHd2 320
#define HEIGHTd2 240


#define FONTH 22
#define FONTW 16
#define FONTMAPH 198
#define MAXBOK 30

#define anflinga0 60
#define anflinga1 5

#define anstar3d 40

#define antom0 25
#define antom1 10
#define antom2 3

#define ANTPLOPP 3
#define ANTS 50
#define grav 9.82



float sintab[256];
float costab[256];

int fullscreen = 0;
int nosound = 0;
int hopptid = 0;

typedef struct {
  int x[256];
  int y[256];
  int w;
  int h;
  SDL_Surface *fontimg;
} fontstr ;

fontstr redfont;

void fillSintab() {
  int i;
  for(i=0;i<256;i++) {
    sintab[i] = sin((float)i/255*2*M_PI);
    costab[i] = cos((float)i/255*2*M_PI);
  }
}

void fillFontstr(fontstr *font) {
  int i;
  font->w = 32;
  font->h = 32;
  for(i=0;i<256;i++) {
    font->x[i]=0;
    font->y[i]=0;
  }
  for(i=44;i<=51;i++) {
    font->x[i] = 2*font->w + (i-44)*font->w;
    font->y[i] = font->h;
  }
  for(i=52;i<=59;i++) {
    font->x[i] = (i-52)*font->w;
    font->y[i] = 2*font->h;
  }
  for(i=97;i<=103;i++) {
    font->x[i] = 3*font->w+(i-97)*font->w;
    font->y[i] = 3*font->h;
  }
  for(i=104;i<=113;i++) {
    font->x[i] = (i-104)*font->w;
    font->y[i] = 4*font->h;
  }
  for(i=114;i<=122;i++) {
    font->x[i] = (i-114)*font->w;
    font->y[i] = 5*font->h;
  }
  font->x[246] = 8*font->w; //
  font->y[246] = 2*font->h;
  font->x[228] = 9*font->w; //
  font->y[228] = 2*font->h;
  font->x[229] = 0;         //
  font->y[229] = 3*font->h;
  font->x[33] = font->w;    //!
  font->y[33] = 0;
  font->x[63] = font->w;    //?
  font->y[63] = 3*font->h;
}

inline void putpixel(SDL_Surface *screen, int x, int y,Uint32 c) {
  Uint32 *p = screen->pixels;
  if(x>0) if(x<screen->w) if(y>0) if(y<screen->h)
    p[x+y*screen->w] = c;
}

/* fett rippad */
Uint32 getpixel(SDL_Surface *surface, int x, int y)
{
  int bpp = surface->format->BytesPerPixel;
  /* Here p is the address to the pixel we want to retrieve */
  Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

  switch(bpp) {
  case 1:
    return *p;

  case 2:
    return *(Uint16 *)p;

  case 3:
    if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
      return p[0] << 16 | p[1] << 8 | p[2];
    else
      return p[0] | p[1] << 8 | p[2] << 16;

  case 4:
    return *(Uint32 *)p;

  default:
    return 0;       /* shouldn't happen, but avoids warnings */
  }
}

/* ganska rippad */
Uint32 getpixel2ARGB(SDL_Surface *surface, int x, int y) {
  SDL_PixelFormat *fmt;
  Uint32 temp;
  Uint32 *pixel;
  Uint8 red, green, blue, alpha;
  int offset = x + y*surface->w;

  fmt=surface->format;
  pixel=surface->pixels;


  /* Get Red component */
  temp=pixel[offset]&fmt->Rmask; /* Isolate red component */
  temp=temp>>fmt->Rshift;/* Shift it down to 8-bit */
  temp=temp<<fmt->Rloss; /* Expand to a full 8-bit number */
  red=(Uint8)temp;
  
  /* Get Green component */
  temp=pixel[offset]&fmt->Gmask; /* Isolate green component */
  temp=temp>>fmt->Gshift;/* Shift it down to 8-bit */
  temp=temp<<fmt->Gloss; /* Expand to a full 8-bit number */
  green=(Uint8)temp;
  
  /* Get Blue component */
  temp=pixel[offset]&fmt->Bmask; /* Isolate blue component */
  temp=temp>>fmt->Bshift;/* Shift it down to 8-bit */
  temp=temp<<fmt->Bloss; /* Expand to a full 8-bit number */
  blue=(Uint8)temp;
  
  /* Get Alpha component */
  temp=pixel[offset]&fmt->Amask; /* Isolate alpha component */
  temp=temp>>fmt->Ashift;/* Shift it down to 8-bit */
  temp=temp<<fmt->Aloss; /* Expand to a full 8-bit number */
  alpha=(Uint8)temp;

  return alpha<<24 | red<<16 | green<<8 | blue;

}

void convertColor(SDL_Surface *surface) {
  Uint32 *newpix;
  int i,j,o=0;

  newpix =  malloc(surface->w * surface->h * 4);
  for(i=0;i<surface->h;i++) for(j=0;j<surface->w;j++) {
    newpix[o] = getpixel2ARGB(surface,j,i);
    o++;
  }
  free(surface->pixels);
  surface->pixels = newpix;
}

void skapaPalett(SDL_Surface *screen,char *pFilnamn) {
   SDL_Color palette[256];
   SDL_Surface *pFil;
   Uint32 color;
   int i;

   pFil = SDL_LoadBMP(pFilnamn);
   for(i=0;i<256;i++) {
     color = getpixel(pFil,i,1);
     palette[i].r = color>>16;
     palette[i].g = (color>>8)&0xff;
     palette[i].b = color&0xff;
   }
  SDL_SetColors(screen,palette,0,256);
}


void blitString(char *text,int sx,int sy,int maxw, SDL_Surface *s,fontstr *font) {
  int i,lastx;
  unsigned char c;
  SDL_Rect srcrect,dstrect;
  
  srcrect.w = font->w;
  srcrect.h = font->h;
  lastx = sx - font->w;
  dstrect.y = sy;

  for(i=0;text[i]!='\0';i++) {
    c = text[i];
    lastx += font->w;
    srcrect.x = font->x[(int)c];
    srcrect.y = font->y[(int)c];
    dstrect.x = lastx;
    if(dstrect.x + font->w > 0)
      SDL_BlitSurface(font->fontimg, &srcrect, s, &dstrect);
    if(maxw!=0 && lastx>maxw) {
      lastx = sx - font->w;
      dstrect.y += font->h + 2;
    }
  }   
}

void tomtefield(SDL_Surface *screen,int drunk) {
  int i;
  static int first = 1;
  static SDL_Surface *tomte0,*tomte1,*tomte2;
  static SDL_Rect rt;
  static float px0[antom0],py0[antom0];
  static float px1[antom1],py1[antom1];
  static float px2[antom2],py2[antom2];

  if(first==1) {
    tomte0 = SDL_LoadBMP("data/tomte0.bmp");
    tomte1 = SDL_LoadBMP("data/tomte1.bmp");
    tomte2 = SDL_LoadBMP("data/tomte2.bmp");
    SDL_SetColorKey(tomte0,SDL_SRCCOLORKEY ,0);
    SDL_SetColorKey(tomte1,SDL_SRCCOLORKEY ,0);
    SDL_SetColorKey(tomte2,SDL_SRCCOLORKEY ,0);
    for(i=0;i<antom0;i++) {
      px0[i] = rand()%screen->w;
      py0[i] = rand()%screen->h;
    }
    for(i=0;i<antom1;i++) {
      px1[i] = rand()%screen->w;
      py1[i] = rand()%screen->h;
    }
    for(i=0;i<antom2;i++) {
      px2[i] = rand()%screen->w;
      py2[i] = rand()%screen->h;
    }
    first=0;     
    printf("tomten har kommit\n");
  }

  rt.w = tomte0->w;
  rt.h = tomte0->h;
  for(i=0;i<antom0;i++) {
    if(px0[i]<=-tomte0->w)
      {px0[i]=screen->w;py0[i]=rand()%screen->h;}
    else {
      px0[i]-=0.2;
      rt.x = (int)px0[i];
      if(drunk)
	rt.y = (int)py0[i]+10*sintab[(rt.x+tomte0->w)%256];
      else
	rt.y = (int)py0[i];
      SDL_BlitSurface(tomte0,0,screen,&rt);
    }
  }
  rt.w = tomte1->w;
  rt.h = tomte1->h;
  for(i=0;i<antom1;i++) {
    if(px1[i]<=-tomte1->w)
      {px1[i]=screen->w;py1[i]=rand()%screen->h;}
    else {
      px1[i]-=0.4;
      rt.x = (int)px1[i];
      if(drunk)
	rt.y = (int)py1[i]+20*sintab[((rt.x+tomte1->w)*2)%256];
      else
	rt.y = (int)py1[i];
      SDL_BlitSurface(tomte1,0,screen,&rt);
    }
  }
  rt.w = tomte2->w;
  rt.h = tomte2->h;
  for(i=0;i<antom2;i++) {
    if(px2[i]<=-tomte2->w)
      {px2[i]=screen->w;py2[i]=rand()%screen->h;}
    else {
      px2[i]-=1.5;
      rt.x = (int)px2[i];
      if(drunk)
	rt.y = (int)py2[i]+40*sintab[((rt.x+tomte2->w)*2)%256];
      else
	rt.y = (int)py2[i];
      SDL_BlitSurface(tomte2,0,screen,&rt);
    }
  }

}

void blitScaleDown(SDL_Surface *screen, SDL_Surface *image, float scale,int sx, int sy) {
  Uint32 color;
  float x,y;
  Uint32 *dstp;
  dstp = image->pixels;
  //  printf("%i %i\n",screen->format->BitsPerPixel,image->format->BitsPerPixel);
   for(y=0;y<image->h-scale;y+=scale) {
    for(x=0;x<image->w-scale;x+=scale) {
      color = getpixel2ARGB(image,x,y);
      if(color!=image->format->colorkey) { 
	putpixel(screen,(int)(sx+x/scale),(int)(sy+(y/scale)),color);
      }
    }
  }

}

void snoe(SDL_Surface *screen, int layer) {
  int i;
  static int first = 1;
  static SDL_Surface *flinga0,*flinga1;
  static SDL_Rect rt;
  static float px0[anflinga0],py0[anflinga0];
  static float px1[anflinga1],py1[anflinga1];


  if(first==1) {
    flinga0 = IMG_Load("data/flinga0.png");
    flinga1 = IMG_Load("data/flinga1.png");

    SDL_SetColorKey(flinga0,SDL_SRCCOLORKEY ,0);
    SDL_SetColorKey(flinga1,SDL_SRCCOLORKEY ,0);

    for(i=0;i<anflinga0;i++) {
      px0[i] = rand()%screen->w;
      py0[i] = rand()%screen->h;
    }
    for(i=0;i<anflinga1;i++) {
      px1[i] = rand()%screen->w;
      py1[i] = rand()%screen->h;
    }
    first=0;     
  }
  if(layer==0) {
    rt.w = flinga0->w;
    rt.h = flinga0->h;
    for(i=0;i<anflinga0;i++) {
      if(py0[i]>=screen->h || px0[i]<-flinga0->w)
	{py0[i]=-flinga0->h;px0[i]=rand()%screen->w;}
      else {
	py0[i]+=0.2;
	px0[i]-=0.1;
	rt.x = (int)px0[i];
	rt.y = (int)py0[i];
	SDL_BlitSurface(flinga0,0,screen,&rt);
	//	blitScaleDown(screen,flinga0,1.3,rt.x,rt.y);
      }
    }
  }
  if(layer==1) {
    rt.w = flinga1->w;
    rt.h = flinga1->h;
    for(i=0;i<anflinga1;i++) {
      if(py1[i]>=screen->w || px1[i]<-flinga1->w)
	{py1[i]=-flinga0->h;px1[i]=rand()%screen->w;}
      else {
	py1[i]+=0.4;
	px1[i]-=0.4;
	rt.x = (int)px1[i];
	rt.y = (int)py1[i];
	SDL_BlitSurface(flinga1,0,screen,&rt);
      }
    }
  }
}

void star3d(SDL_Surface *screen,int new,int zooma,float rotera) {
  static SDL_Surface *bild[3];
  static float starx[anstar3d],stary[anstar3d],starz[anstar3d];
  static int start[anstar3d];
  int sx,sy,i;
  static int first = 1;
  float f;
  
  if(first) {
    bild[0] = IMG_Load("data/star.png");
    bild[1] = IMG_Load("data/paket0.png");
    bild[2] = IMG_Load("data/paket1.png");
    SDL_SetColorKey(bild[0],SDL_SRCCOLORKEY,0);
    SDL_SetColorKey(bild[1],SDL_SRCCOLORKEY,0);
    SDL_SetColorKey(bild[2],SDL_SRCCOLORKEY,0);
    new =1;
    first = 0;
  }
  for(i=0;i<anstar3d;i++) {
    if(new) {
      starx[i] = rand()%WIDTH-WIDTHd2;
      stary[i] = rand()%HEIGHT-HEIGHTd2;
      starz[i] = (rand()%100)+1;
      start[i] = 0;
    }
    if(zooma) {
      starz[i]-=1; 
    }
    if(starz[i]<=0) {
      starz[i] = 100;
      starx[i] = rand()%WIDTH-WIDTHd2;
      stary[i] = rand()%HEIGHT-HEIGHTd2;

      switch (rand()%100) {
      case 1:
	start[i]=1;
	break;
      case 2:
	start[i]=2;
	break;
      default:
	start[i]=0;
      }
    }
    if(rotera>0) {
      f = starx[i];
      starx[i] = starx[i]*cos(rotera)-stary[i]*sin(rotera);
      stary[i] = stary[i]*cos(rotera)+f*sin(rotera);
    }
    sx = (int)(starx[i]/starz[i]*32)+WIDTHd2;
    sy = (int)(stary[i]/starz[i]*32)+HEIGHTd2+30;
    if(sx>0)if(sx<WIDTH)if(sy>0)if(sy<HEIGHT)
      blitScaleDown(screen,bild[start[i]],starz[i]/64,sx,sy);
  }

}

int present(SDL_Surface *screen, Uint32 tid) {
  static int first=1;
  static SDL_Surface *s3k7,*seven;
  static Uint32 starttid;
  Uint32 dtid; 
  int distans,mdistans;
  SDL_Rect rs,rd;
  static int stage=0;

  if(first) {
    s3k7 = IMG_Load("data/s3k7.png");
    seven = IMG_Load("data/7.png");
    starttid = tid;
    first=0;
  }
  dtid = tid-starttid;
  SDL_FillRect(screen,0,0);
  
  blitString("the glgg demo",100,400,0,screen,&redfont);

  if(stage==0) {
    rs.x = (screen->w-s3k7->w)/2;
    rs.y = dtid/30-s3k7->h;
    SDL_BlitSurface(s3k7,0,screen,&rs);
    if(rs.y>=100-s3k7->h) stage++;
  } else if(stage==1){
    mdistans = (dtid-3000)/300;
    distans = sin(dtid/100)*mdistans;
    rs.x = (screen->w-s3k7->w)/2-mdistans-distans;
    rs.y = 100-s3k7->h;
    rd.x = 0;
    rd.y = 0;
    rd.w = 120;
    rd.h = s3k7->h;
    SDL_BlitSurface(s3k7,&rd,screen,&rs);
    rs.x = (screen->w-s3k7->w)/2+mdistans+distans+120;
    rs.y = 100-s3k7->h;
    rd.x = 120;
    rd.y = 0;
    rd.w = s3k7->w-120;
    rd.h = s3k7->h;
    SDL_BlitSurface(s3k7,&rd,screen,&rs);
    if(mdistans>=15) stage++;
  } else if(stage==2) {
    rs.x = (screen->w-s3k7->w)/2-20;
    rs.y = 100-s3k7->h;
    rd.x = 0;
    rd.y = 0;
    rd.w = 120;
    rd.h = s3k7->h;
    SDL_BlitSurface(s3k7,&rd,screen,&rs);
    rs.x = (screen->w-s3k7->w)/2+20+120;
    rs.y = 100-s3k7->h;
    rd.x = 120;
    rd.y = 0;
    rd.w = s3k7->w-120;
    rd.h = s3k7->h;
    SDL_BlitSurface(s3k7,&rd,screen,&rs);
    rd.x = (screen->w-s3k7->w)/2-20+120;
    rd.y = 100-s3k7->h;
    SDL_BlitSurface(seven,0,screen,&rd);
  }

  if(dtid>10000) return 1;
  return 0;
}

void ritaElips(SDL_Surface *screen, int cx,int cy,float rw,float rh,Uint32 color) {
  int x,y;  
  for(y=0;y<rh;y++) {
    for(x=0;x<rw;x++) {
      if((x/rw)*(x/rw)+(y/rh)*(y/rh)<1) {
	putpixel(screen,cx+x,cy+y,color);
	putpixel(screen,cx-x+1,cy+y,color);
	putpixel(screen,cx+x,cy-y+1,color);
	putpixel(screen,cx-x+1,cy-y+1,color);
      }
    }
  }

}

void warpspeed(SDL_Surface *screen, int warp) {
  static float zpos=0.95,tzpos=1.65;
  Uint32 color = 0x0000ff;
  int j;
  static float apanap=0;
  float x,y,eli=0;
  static SDL_Surface *enterprise;
  static SDL_Surface *black;
  static int first = 1;

  if(first) {
    enterprise =  IMG_Load("data/tomtebak.png");
    if(enterprise==NULL) {
      printf("Klingons!!\n");
    }
    black =  IMG_Load("data/black.png");
    if(black==NULL) printf("ett fel av typen 1 har intrffat\n");
    SDL_SetColorKey(enterprise,SDL_SRCCOLORKEY,0x000000);
    first = 0;
  }
  if( zpos<5) {
    x = 250/tzpos + 200;
    y = 200/tzpos + 200;
    blitScaleDown(screen,black,tzpos,x,y);
    if(warp) tzpos*=1.01; 
    x = 250/tzpos + 200;
    y = 200/tzpos + 200;
    blitScaleDown(screen,enterprise,tzpos,x,y);
    
   
    if(warp) {  
      for(j=0;j<20;j++) {
	x = (j+250)/zpos + 200;
	y = (200)/zpos + 200;
	putpixel(screen,(int)x,(int)y,color);
	x = (j+200)/zpos + 200;
	y = (200)/zpos + 200;
	putpixel(screen,(int)x,(int)y,color);
      }
      zpos*=1.01;
    }
  } else {
    x = 250/tzpos + 200;
    y = 200/tzpos + 200;
    eli = 10*sintab[(int)apanap];
    ritaElips(screen,(int)x+5,(int)y,eli,eli*3,0);
    if(apanap<254) apanap+=2;
    eli = 10*sintab[(int)apanap];
    //  blitScaleDown(screen,black,tzpos,x,y);
    ritaElips(screen,(int)x+5,(int)y,eli,eli*3,0x0000ff);
  }
}

void nextCandleFrame(SDL_Surface *thisFrame, int nutid,float apa) {
  Uint8 *nextPixels;
  Uint8 *pixpoint = thisFrame->pixels;
  int i,x,y,offset,w=thisFrame->w,h=thisFrame->h,s=w*h;
  static SDL_Surface *pattern;
  static int first=1;
  SDL_Rect r;

  if(first) {
    pattern = SDL_LoadBMP("data/firePattern.bmp");
    SDL_SetColorKey(pattern,SDL_SRCCOLORKEY,0);
    first=0;
  }

  nextPixels = malloc(thisFrame->w*thisFrame->h);

  for(i=0;i<s;i++) {nextPixels[i]=0;}

  r.x=w/2+4*sin(nutid/80+apa)-pattern->w/2;
  r.y=thisFrame->h-6+4*cos(nutid/80+apa)-pattern->h/2;
  SDL_BlitSurface(pattern,0,thisFrame,&r);
  r.x=w/2+4*sin(nutid*3.5/80+apa)-pattern->w/2;
  r.y=thisFrame->h-6+4*cos(nutid*3.5/80+apa)-pattern->h/2;
  SDL_BlitSurface(pattern,0,thisFrame,&r);
  r.x=w/2+4*sin(-nutid/400+apa)-pattern->w/2;
  r.y=thisFrame->h-6+4*cos(-nutid/400+apa)-pattern->h/2;
  SDL_BlitSurface(pattern,0,thisFrame,&r); 
 
  for(y=1;y<thisFrame->h-1;y++) {
    for(x=2;x<w-2;x++) {
      offset = x+y*w;
      nextPixels[offset]= (pixpoint[offset-1]+pixpoint[offset+1]+
			   pixpoint[offset+w+1]+pixpoint[offset+w]+pixpoint[offset+w-1]+
			   pixpoint[offset+w+w+1]+pixpoint[offset+w+w]+pixpoint[offset+w+w-1]+
			   pixpoint[offset-1]+pixpoint[offset+1]+
			   pixpoint[offset+w+1]+pixpoint[offset+w-1]+
			   pixpoint[offset-2]+pixpoint[offset+2]+
			   pixpoint[offset+w+2]+pixpoint[offset+w-2]
			   )>>4; 
    }
  }
  // free(thisFrame->pixels);
  // thisFrame->pixels = nextPixels;
  for(i=0;i<s;i++) pixpoint[i]=nextPixels[i];
}

int blossa(SDL_Surface *screen,int nutid) {
  SDL_Rect r;
  int xp = 10,yp=10;
  static int first = 1;
  static SDL_Surface *bf,*bg,*lf,*lg,*of,*og,*sf,*sg,*af,*ag,*flaska;
  static int stid;
  int en = 300;
  Uint32 dtid;

  if(first) {
    stid = nutid;
    bf = IMG_Load("data/bf.png");
    bg = IMG_Load("data/bg.png");
    lf = IMG_Load("data/lf.png");
    lg = IMG_Load("data/lg.png");
    of = IMG_Load("data/of.png");
    og = IMG_Load("data/og.png");
    sf = IMG_Load("data/sf.png");
    sg = IMG_Load("data/sg.png");
    af = IMG_Load("data/af.png");
    ag = IMG_Load("data/ag.png");
    flaska = IMG_Load("data/flaska.png");
    first=0;
  }

  r.x = xp;
  r.y = yp;
  SDL_BlitSurface(bg,0,screen,&r);
  r.x = xp+64;
  r.y = yp;
  SDL_BlitSurface(lg,0,screen,&r);
  r.x = xp+64+64;
  r.y = yp;
  SDL_BlitSurface(og,0,screen,&r);
  r.x = xp+64+64+64;
  r.y = yp;
  SDL_BlitSurface(sg,0,screen,&r);
  r.x = xp+64+64+64+64;
  r.y = yp;
  SDL_BlitSurface(sg,0,screen,&r);
  r.x = xp+64+64+64+64+64;
  r.y = yp;
  SDL_BlitSurface(ag,0,screen,&r);
 
  dtid = nutid-stid;

  if(dtid>en*8 && dtid<=16*en) dtid-=8*en;
  if(dtid>en*16 && dtid<=24*en) dtid-=16*en;

  if(dtid<en) {
    r.x = xp;
    r.y = yp;
    SDL_BlitSurface(bf,0,screen,&r);
  } else if(dtid<en+en) {
    r.x = xp+64;
    r.y = yp;
   SDL_BlitSurface(lf,0,screen,&r);   
  } else if(dtid<en+en+en+en) {
    r.x = xp+64+64;
    r.y = yp;
   SDL_BlitSurface(of,0,screen,&r);   
  } else if(dtid<en+en+en+en+en) {
    r.x = xp+64+64+64;
    r.y = yp;
   SDL_BlitSurface(sf,0,screen,&r);   
  } else if(dtid<en+en+en+en+en+en) {
    r.x = xp+64+64+64+64;
    r.y = yp;
   SDL_BlitSurface(sf,0,screen,&r);   
  } else if(dtid<en+en+en+en+en+en+en) {
    r.x = xp+64+64+64+64+64;
    r.y = yp;
   SDL_BlitSurface(af,0,screen,&r);   
  }
  
  if(dtid>24*en && dtid<27*en) {
    r.x = 100;
    r.y = 100;
    SDL_BlitSurface(flaska,0,screen,&r);   
  } else if((dtid>=27*en && dtid<=28*en)||(dtid>29*en && dtid<=30*en)) {
    r.x = xp;
    r.y = yp;
    SDL_BlitSurface(bf,0,screen,&r);
    r.x = xp+64;
    r.y = yp;
    SDL_BlitSurface(lf,0,screen,&r);   
    r.x = xp+64+64;
    r.y = yp;
    SDL_BlitSurface(of,0,screen,&r);  
    r.x = xp+64+64+64;
    r.y = yp;
    SDL_BlitSurface(sf,0,screen,&r);
    r.x = xp+64+64+64+64;
    r.y = yp;
    SDL_BlitSurface(sf,0,screen,&r);
    r.x = xp+64+64+64+64+64;
    r.y = yp;
    SDL_BlitSurface(af,0,screen,&r);   
  }
  
  if(dtid>31*en) return 1;
  return 0;
}

int ljusstake(SDL_Surface *bild, Uint32 nutid) {
  int i;
  static int apan=480;
  static Uint32 stid;
  Uint32 dtid;
  SDL_Rect rs,rd;
  static int first=1;
  static SDL_Surface *eld[4],*iStake, *iGreets;

  if(first) {
    iStake = IMG_Load("data/Ljus.gif");
    SDL_SetColorKey(iStake,SDL_SRCCOLORKEY,0x00ff00);
    stid = nutid;
    for(i=0;i<4;i++) {
      eld[i] = SDL_CreateRGBSurface(SDL_SWSURFACE,40,128,8,0,0,0,0);
      skapaPalett(eld[i],"data/firePalette.bmp");
      SDL_FillRect(eld[i],0,0);
    }
    iGreets = IMG_Load("data/greets.png");
    
    first=0;
  }
  

  SDL_FillRect(bild,0,0);
  rs.x = 45;
  rs.y = 114;
  SDL_BlitSurface(iStake,0,bild,&rs);
  
  rd.x = rs.x+33-16;
  rd.y = rs.y+98-128;
  nextCandleFrame(eld[0],nutid,0);
  SDL_BlitSurface(eld[0],0,bild,&rd);
  rd.x = rs.x+113-16;
  rd.y = rs.y+76-128;
  nextCandleFrame(eld[1],nutid,3.14);
  SDL_BlitSurface(eld[1],0,bild,&rd);
  rd.x = rs.x+191-16;
  rd.y = rs.y+56-128;
  nextCandleFrame(eld[2],nutid,1.8);
  SDL_BlitSurface(eld[2],0,bild,&rd);
  rd.x = rs.x+271-16;
  rd.y = rs.y+34-128;
  nextCandleFrame(eld[3],nutid,4);
  SDL_BlitSurface(eld[3],0,bild,&rd);
  
  rs.x=370;
  rs.y=apan;
  apan-=2;
  SDL_BlitSurface(iGreets,0,bild,&rs);
  return 0;
}

int tannenbaum(SDL_Surface *screen,Uint32 nutime) {
  static int first=1;
  static SDL_Surface *baum;
  static Uint32 stime;
  Uint32 dtime;

  if(first) {
    baum = IMG_Load("data/tannenbaum.png");
    stime=nutime;
    first=0;
  }
  dtime = nutime-stime;
  if(dtime<2000) SDL_BlitSurface(baum,0,screen,0);
  else return 1;
  
  return 0;
}

int plasma(SDL_Surface *bild,Uint32 nutid, int apanap) {
  int i;
  static int first =1;
  static Uint32 stid;
  Uint32 dtid;
  int x,y;
  static int scrollerx=10,scrollermove = 10;
  static SDL_Surface *plasma;
  static int attx[antalAtt],atty[antalAtt];
  float ap,f;
  Uint8 *p;
  SDL_Rect rd;
  static char scroller[] = "feel the glgg           coke? coffee? tea?   no!! glgg is the superior dryck at juletid";

  if(first) {
    plasma = SDL_CreateRGBSurface(SDL_SWSURFACE,WIDTH,HEIGHT-40,8,0,0,0,0);
    skapaPalett(plasma,"data/weinPalette.bmp");
    for(i=0;i<antalAtt;i++) {
      attx[i] = rand()%WIDTH;
      atty[i] = rand()%HEIGHT;
    }
    stid = nutid;
    first=0;
  }
 
  dtid = nutid-stid;
  ap = 90*sintab[(apanap<<2)%256];
  attx[0] = plasma->w/2 + 80*sintab[(apanap<<3)%256];
  atty[0] = plasma->h/2 + 80*costab[(apanap<<3)%256];
  p = plasma->pixels;
  for(y=0;y<plasma->h;y++) {
    for(x=0;x<plasma->w;x++) {
      f=0;
      for(i=0;i<antalAtt;i++) {
	f += sintab[(int)(hypot(attx[i]-x,atty[i]-y)+ap)%256];
      }
      *p = (int)(128*(f+antalAtt));
      p++;
	}
  }
  rd.y = 40;
  rd.x = 0;
  SDL_BlitSurface(plasma, 0, bild, &rd);
  rd.x = 0;
  rd.y = 0;
  rd.w = WIDTH;
  rd.h = 40;
  SDL_FillRect(bild,&rd,0);
  if( dtid > 4000) {
    for(i=0;i<scrollermove;i++) {
      // for smooth scrolling
      rd.x = 0;
      rd.y = 0;
      rd.w = WIDTH;
      rd.h = 40;
      SDL_FillRect(bild,&rd,0);
      scrollerx--;
      blitString(&scroller[0],scrollerx,4,0,bild,&redfont);
      SDL_UpdateRect(bild,0,0,WIDTH,40);
    }
  } else {
    blitString(&scroller[0],scrollerx,4,0,bild,&redfont);
  }
  if(dtid>28000) return 1;
  return 0;
}

int tomteEffekt(SDL_Surface *bild,Uint32 nutid) {
  static int first=1;
  static SDL_Surface *iLitenapanap,*iMoon;
  static Uint32 stid;
  Uint32 dtid;
  SDL_Rect rd;

  if(first) {
    iMoon = IMG_Load("data/256MOONE.PNG");
    iLitenapanap = IMG_Load("data/litenapanap.png");
    SDL_SetColorKey(iLitenapanap,SDL_SRCCOLORKEY,0);
    stid = nutid;
    first=0;  
  }
   SDL_FillRect(bild,0,0);
  dtid = nutid-stid;
  if(dtid<7500) {
    rd.x=bild->w-280;
    rd.y=10;
    SDL_BlitSurface(iMoon,0,bild,&rd);
    tomtefield(bild,0);
    snoe(bild,0);
    snoe(bild,1);
  } else {
    rd.x=bild->w-280;
    rd.y=10;
    SDL_BlitSurface(iMoon,0,bild,&rd);
    rd.x=bild->w-220;
    rd.y=130;
    SDL_BlitSurface(iLitenapanap,0,bild,&rd);
    tomtefield(bild,1);
    snoe(bild,0);
    snoe(bild,1);
    blitString("to much glgg?",50,50,0,bild,&redfont);
  }
  if(dtid>15000) return 1;
  return 0;
}


void starSlump(SDL_Surface *screen) {
  int antal =20;
  int i;
  int x,y;
  float size;
  static int first = 1;
  static SDL_Surface *star;

  if(first) {
    star = IMG_Load("data/star.png");
    first=0;
  }
  for(i=0;i<antal;i++) {
    x = rand()%screen->w;
    y = rand()%screen->h;
    size = (rand()%2)+0.5;
    blitScaleDown(screen,star,size,x,y);
  }


}


int warpEffekt(SDL_Surface *bild,Uint32 nutid) {
  static int first=1;
  static Uint32 stid;
  Uint32 dtid;
  SDL_Rect rd;
  static SDL_Surface *iTomtewarp,*iTomtewarp0;

  if(first) {
    SDL_FillRect(bild,0,0);
    starSlump(bild);
    iTomtewarp0 = IMG_Load("data/tomtewarp0.png");
    iTomtewarp = IMG_Load("data/tomtewarp.png");
    SDL_SetColorKey(iTomtewarp0,SDL_SRCCOLORKEY,0);
    SDL_SetColorKey(iTomtewarp,SDL_SRCCOLORKEY,0);
    stid = nutid;
    first=0;
  }
  dtid = nutid-stid;
  blitString("take us to  warpspeed,  rudolph",300,20,bild->w,bild,&redfont);
  if (dtid<3000)
    warpspeed(bild,0);
  else if(dtid<6000)
    warpspeed(bild,1);
  else if(dtid<12000) {
    SDL_FillRect(bild,0,0);
    star3d(bild,0,1,0);
    rd.x=(bild->w-iTomtewarp->w)/2;
    rd.y=250;
    SDL_BlitSurface(iTomtewarp0,0,bild,&rd);
  } else {
    SDL_FillRect(bild,0,0);
    star3d(bild,0,1,0.03);
    rd.x=(bild->w-iTomtewarp->w)/2;
    rd.y=250;
    SDL_BlitSurface(iTomtewarp,0,bild,&rd);
  }
  if(dtid>15000)
    return 1;
  return 0;
}

int parser(int argc, char *argv[]) {
  int i=1;
  while(i<argc) {
    if(strcmp(argv[i],"-fs")==0)
      fullscreen = 1;
    else if(strcmp(argv[i],"-ns")==0)
      nosound = 1;
    else if(strcmp(argv[i],"-start")==0) {
      i++;
      hopptid = atoi(argv[i]);
      if(hopptid<0 || hopptid>600) {
	printf("syntax: -start seconds\nWhere seconds is a number over 0 and less then 600\n");
	return 1;
      }
      hopptid*=1000;
    } else {
      printf("Options are:\n-ns        :no sound\n-fs        :fullscreen\n-start #n  :start #n-seconds in to the demo (doesn't effect sound only visuals)\n");
      return 1;
    }
    i++;
  }
  return 0;
}

int tomtebloss(SDL_Surface *screen,int x, int y,Uint32 time){
  static int fulmeter=320;
  static Uint32 starttid;
  Uint32 dtime;
  static int first=1;
  static SDL_Surface *tomtepinne,*brinn, *tomtepub;
  SDL_Rect rs,br,brrs;
  SDL_FillRect(screen,0,0);
  rs.x=x-10;
  rs.y=y-320;
  
  br.x=0;
  br.w=20;
  
  br.y=0;
  br.h=fulmeter-(time-starttid)/80;
  
  brrs.x=rs.x;
  brrs.y=rs.y;

  if(first) {
    starttid=time;
    first=0;
    tomtepinne =  IMG_Load("data/tb.png");
    if(tomtepinne==NULL) {
      printf("blota!!\n");
    }
    
    tomtepub =  IMG_Load("data/tbub.png");
    if(tomtepub==NULL) {
      printf("blota brunnit!!\n");
    }
    
  }
  dtime=time-starttid;
  
  SDL_BlitSurface(tomtepub,0,screen,&brrs);
  SDL_BlitSurface(tomtepinne,&br,screen,&rs);
  static float xspeed[ANTS];
  static float yspeed[ANTS];
  static int ypos[ANTS];
  static int xpos[ANTS];
  static int xlil[ANTS][ANTPLOPP];
  static int ylil[ANTS][ANTPLOPP];
  int i=0;
  static int skapa=0;
  for(i=0;i<ANTS;i++){
    
    int gang;
    
    if(rand()%50==1){
      xspeed[skapa]=(rand()%9)-4;
      yspeed[skapa]=(rand()%9)-4;
      xpos[skapa]=x;
      ypos[skapa]=y;
      if((time-starttid)/80>=200)
	xpos[skapa]=-10000;
      skapa++;
      if(skapa>=ANTS)
	skapa=0;
    }
    
    
    
    for(gang=0;gang<=ANTPLOPP;gang++){
      
      xlil[i][gang]=xpos[i]+rand()%12-6;
      ylil[i][gang]=ypos[i]+(rand()%12-6)-(time-starttid)/80;
      putpixel(screen,xlil[i][gang],ylil[i][gang],0xffffff);
      putpixel(screen,xlil[i][gang]-1,ylil[i][gang],0xFFFF00);
      putpixel(screen,xlil[i][gang]-1,ylil[i][gang]-1,0xffddff);
      putpixel(screen,xlil[i][gang]-1,ylil[i][gang]+1,0xee9900);
      putpixel(screen,xlil[i][gang]+1,ylil[i][gang],0xddffff);
      putpixel(screen,xlil[i][gang]+1,ylil[i][gang]+1,0xeeFF00);
      putpixel(screen,xlil[i][gang]+1,ylil[i][gang]-1,0xffffff);
      putpixel(screen,xlil[i][gang],ylil[i][gang]-1,0xffffff);
      putpixel(screen,xlil[i][gang],ylil[i][gang]+1,0xFFFF00);
    }
    ypos[i]+=yspeed[i];
    xpos[i]+=xspeed[i];
    yspeed[i]+=grav*0.005;
  }
  if(dtime>18000)return 1;
  return 0;
}






int main(int argc, char *argv[]) {
  SDL_Surface *bild;
  int apanap=0;
  int done=0;
  SDL_Event event;
  Uint32 vflags;
  Uint32 nutid=0,starttid;
  int effekt=0;
  

  if(parser(argc, &argv[0])) {
    exit(1);
  }

  srand((unsigned)time(NULL));
  fillSintab();

  /* fixa fonten */
  fillFontstr(&redfont);
  redfont.fontimg = SDL_LoadBMP("data/020.bmp");
  SDL_SetColorKey(redfont.fontimg,SDL_SRCCOLORKEY ,0);

  if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
    fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);
 
  if(fullscreen)
    vflags = SDL_SWSURFACE|SDL_FULLSCREEN;
  else
    vflags = SDL_SWSURFACE;

  bild = SDL_SetVideoMode(WIDTH, HEIGHT, 32,vflags);
  if ( bild == NULL ) { 
    fprintf(stderr, "Unable to set 640x480 video: %s\n", SDL_GetError());
    exit(1);
  }
  if(fullscreen) {
    SDL_ShowCursor(SDL_DISABLE);
  }

  /* starta musiken, fulmetod */
  if(!nosound)
    system("mpg123 -q data/laten2.mp3 &");
    
  starttid = SDL_GetTicks() - hopptid;
  usleep(2000000);
  while(!done) {
    apanap++;
    nutid = SDL_GetTicks() - starttid;
   
    if(effekt==0)
      effekt+=blossa(bild,nutid);
    if(effekt==1)
      effekt+=tomtebloss(bild,300,360,nutid);
    if(effekt==2)
      effekt+=present(bild,nutid);
    if(effekt==3)
      effekt+=plasma(bild,nutid,apanap);
    if(effekt==4)
      effekt+=tannenbaum(bild,nutid);
    if(effekt==5)
      effekt+=tomteEffekt(bild,nutid);
    if(effekt==6) 
      effekt+=warpEffekt(bild,nutid);
    if(effekt==7)
      effekt+=ljusstake(bild,nutid);
   
    //    blossa(bild,nutid);
    //    SDL_FillRect(bild,0,0);
    // present(bild,nutid);

    SDL_UpdateRect(bild,0,0,0,0);
    while( SDL_PollEvent(&event)) {
      switch (event.type) {
      case SDL_KEYDOWN:
	if ( event.key.keysym.sym == SDLK_ESCAPE ) { done = 1; }
	break;
      case SDL_QUIT:
	done=1;
      }
    }
  }

  printf("FPS=%f\n",(float)apanap/(float)nutid*1000);
  /* stanna musiken, fulmetod */
  if(!nosound)
    system("killall mpg123");
  SDL_FreeSurface(bild);
  SDL_FreeSurface(redfont.fontimg);

  exit(1);
}
